

C     ==============
      program astab2
C     ==============

C--
C--   Table of alpha_s versus Q2
C--

      implicit double precision (a-h,o-z)

      parameter (nwpawc = 1000000)
      common /pawc/ hmemor(nwpawc)

      common /xqgri/ xxtab(100),qqtab(100),nxx,nqq
     
      real t1,t2,t3

C--   Hbook initialisation
      call hlimit(nwpawc)

C--   x-Q2 table for plotting
      nxx        = 1
      xxtab(1)   = 1.D-3
      nqq        = 50
      qqtab(1)   = 1.D0
      qqtab(nqq) = 8315.25
      call maketab

C--   Stop/print
      call ep_stop(1,0)

C--   Open input ntuple file
      call timex(t1)
      call ep_open(20,'../fits/mbfit1m.stfnt2',ierr)

C--   Print alpha_s table
      call timex(t2)
      write(6,1000)
      do iq = 1,nqq

        qq  = qqtab(iq)

        ad   = ep_alfa(qq,-1.D0,ierr)
        ac   = ep_alfa(qq, 0.D0,ierr)
        au   = ep_alfa(qq, 1.D0,ierr)

        write(6,'(I5,4E12.4)') iq,qq,ac,ad-ac,au-ac

      enddo
      call timex(t3)

      write(6,'(/'' Time spent init ='',F6.2)') t2-t1
      write(6,'( ''            loop ='',F6.2)') t3-t2
      write(6,'( ''           total ='',F6.2)') t3-t1

 1000 format(/'    #       Q2       alfas',
     +        '      lower err   upper err')

      end

C     ==================
      subroutine maketab
C     ==================

C--   Generate a logarithmic table of x and Q2 values

      implicit double precision (a-h,o-z)

      common /xqgri/ xxtab(100),qqtab(100),nxx,nqq

      if(nxx.gt.1) then
        xmi  = xxtab(1)
        xma  = xxtab(nxx)
        xmil = log(xmi)
        xmal = log(xma)
        bw   = (xmal-xmil)/(nxx-1)
        do i = 1,nxx
          xl       = xmil + (i-1)*bw
          xxtab(i) = exp(xl)
        enddo
      endif

      if(nqq.gt.1) then
        qmi  = qqtab(1)
        qma  = qqtab(nqq)
        qmil = log(qmi)
        qmal = log(qma)
        bw   = (qmal-qmil)/(nqq-1)
        do i = 1,nqq
          ql       = qmil + (i-1)*bw
          qqtab(i) = exp(ql)
        enddo
      endif

      return
      end
